/*
 * Copyright (c) 2009, Jonathan L. Woodring and Han-Wei Shen
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of The Ohio State University, Jonathan
 *       L. Woodring, Han-Wei Shen, nor the names of its contributors
 *       may be used to endorse or promote products derived from this 
 *       software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY JONATHAN L. WOODRING AND HAN-WEI SHEN
 * ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OHIO
 * STATE UNIVERSITY, JONATHAN L. WOODRING, OR HAN-WEI SHEN BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __FMAPPER_H__
#define __FMAPPER_H__ 1

#include "Mapper.h"
#include "AllocArray.h"
#include <stdio.h>
 
class FMapper : public Mapper {
 public:
  FMapper(char* meta);
  ~FMapper();

  virtual AllocArray<unsigned int>* getDims();
  virtual float getFloat(AllocArray<unsigned int>& coords);
  virtual int getInt(AllocArray<unsigned int>& coords);
  //virtual int isValid();
  //void* vector();
  virtual float getFloat(unsigned int coord);
  virtual int getInt(unsigned int coord);
  virtual void getFloat
    (float* buffer, unsigned int coord, unsigned int count);
  virtual void getInt
    (int* buffer, unsigned int coord, unsigned int count);
  virtual void getFloat
    (float* buffer, unsigned int coord, unsigned int count,
     unsigned int skip);
  virtual void getInt
    (int* buffer, unsigned int coord, unsigned int count,
     unsigned int skip);
  virtual unsigned int getSize();
  virtual float getMin();
  virtual float getMax();
  virtual void close();
  virtual void open();
  virtual int isOpen();
  virtual AllocArray<unsigned int>* getOriginalDims();
  virtual unsigned int getSplitTotal();

 private:
  char* fn;
  FILE* file;
  float* arrayf;
  int* arrayi;
  //int valid;
  size_t end;
  size_t size;
  size_t skip;
  AllocArray<unsigned int> dims;
  AllocArray<unsigned int> first;
  AllocArray<unsigned int> last;
  AllocArray<unsigned int> oridims;
  unsigned int splittotal;

  float min;
  float max;
};

#endif
