/*
 * Copyright (c) 2009, Jonathan L. Woodring and Han-Wei Shen
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of The Ohio State University, Jonathan
 *       L. Woodring, Han-Wei Shen, nor the names of its contributors
 *       may be used to endorse or promote products derived from this 
 *       software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY JONATHAN L. WOODRING AND HAN-WEI SHEN
 * ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OHIO
 * STATE UNIVERSITY, JONATHAN L. WOODRING, OR HAN-WEI SHEN BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __STACK_H__
#define __STACK_H__

template <class Item>
class StackNode;

template <class Item>
class Stack;

template <class Item>
class StackNode {
 public:
  StackNode();
  ~StackNode();

  Item item;
  StackNode<Item> *next;
};

template <class Item>
class Stack {
 public:

  Stack();
  ~Stack();

  Item& Top();
  int Size() const;
  Item Pop();
  void Push(Item item);

 private:
  int size;
  StackNode<Item> *top;
};

template <class Item>
inline StackNode<Item>::StackNode()
{
}

template <class Item>
inline StackNode<Item>::~StackNode()
{
}

template <class Item>
inline Stack<Item>::Stack() {
  top = 0;
  size = 0;
}

template <class Item>
inline Stack<Item>::~Stack() {
  while(top) {
    StackNode<Item>* t = top;
    top = top->next;
    delete t;
  }
}

template <class Item>
inline void Stack<Item>::Push(Item item) {
  StackNode<Item>* t = new StackNode<Item>;
  t->next = top;
  top = t;
  size++;

  t->item = item;
}

template <class Item>
inline Item Stack<Item>::Pop() {
  StackNode<Item>* t = top;
  Item i = t->item;

  top = top->next;
  delete t;
  size--;

  return i;
}

template <class Item>
inline int Stack<Item>::Size() const {
  return size;
}

template <class Item>
inline Item& Stack<Item>::Top() {
  return top->item;
}

#endif






